# -*- python -*-
# $RCSfile: forcedensity_.py,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2005/06/15 21:14:37 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from oof2.common.IO import parameter
from oof2.engine import problem

import types
from oof2.SWIG.common import devel

PropertyRegistration(
    'Mechanical:ForceDensity:ConstantForceDensity', ForceDensity,
    "oof2.SWIG.engine.property.forcedensity.forcedensity",100,
    [parameter.FloatParameter('gx', 0.0, tip="horizontal-direction of the body force density"),
     parameter.FloatParameter('gy', -9.8, tip="y-direction of the body force density (pointing up on your screen)"),
     parameter.FloatParameter('gz', 0, tip="z-direction of the body force density (out-of-the-plane of the screen)")],
    fluxes=[problem.Stress],
    propertyType="Force Density")

# Repr refers to registered name, not class name.    
def _ForceDensity___repr__(self):
    return "ForceDensity(name='%s', gx=%s, gy=%s, gz=%s)" % \
           (self.name(), `self.fdensity_x()`, `self.fdensity_y()`, `self.fdensity_z()`)

ForceDensityPtr.__repr__ = _ForceDensity___repr__
